﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.2),
    on July 31, 2022, at 16:20
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.2'
expName = 'HoverCat'  # from the Builder filename that created this script
expInfo = {'participant': ''}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\17703\\Desktop\\TouchCat\\HoverCat_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1536, 864], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color='black', colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}
ioSession = ioServer = eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='event')

# Initialize components for Routine "Start_screen"
Start_screenClock = core.Clock()
image = visual.ImageStim(
    win=win,
    name='image', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.2, 1),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
start_stim = visual.Rect(
    win=win, name='start_stim',
    width=(0.2, 0.2)[0], height=(0.2, 0.2)[1],
    ori=0.0, pos=(0, 0.07), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor=None, fillColor=None,
    opacity=None, depth=-1.0, interpolate=True)
mouse2 = event.Mouse(win=win)
x, y = [None, None]
mouse2.mouseClock = core.Clock()
mouserec2=mouse2.getPos()
minRT=.1

# Initialize components for Routine "Trials"
TrialsClock = core.Clock()
Task1_Stim = visual.ImageStim(
    win=win,
    name='Task1_Stim', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.2, 1),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=True, depth=0.0)
B_rect = visual.Rect(
    win=win, name='B_rect',
    width=(0.1, 0.15)[0], height=(0.1, 0.15)[1],
    ori=0.0, pos=(0.28, -0.2), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor=None, fillColor='yellow',
    opacity=None, depth=-1.0, interpolate=True)
A_rect = visual.Rect(
    win=win, name='A_rect',
    width=(0.1, 0.15)[0], height=(0.1, 0.15)[1],
    ori=0.0, pos=(-0.28, -0.2), anchor='center',
    lineWidth=1.0,     colorSpace='rgb',  lineColor=None, fillColor='blue',
    opacity=None, depth=-2.0, interpolate=True)
mouse = event.Mouse(win=win)
x, y = [None, None]
mouse.mouseClock = core.Clock()
mouserec=mouse.getPos()
minRT=.1
Resp = ''

# Initialize components for Routine "Feedback"
FeedbackClock = core.Clock()
respond = ''
Timeout = 0
total_score = 0
avg_acc = 1
acc_hist = []

win1 = visual.TextStim(win=win, name='win1',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
lose1 = visual.TextStim(win=win, name='lose1',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# set up handler to look after randomisation of conditions etc
task_loop = data.TrialHandler(nReps=10.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Task_List.xlsx'),
    seed=None, name='task_loop')
thisExp.addLoop(task_loop)  # add the loop to the experiment
thisTask_loop = task_loop.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTask_loop.rgb)
if thisTask_loop != None:
    for paramName in thisTask_loop:
        exec('{} = thisTask_loop[paramName]'.format(paramName))

for thisTask_loop in task_loop:
    currentLoop = task_loop
    # abbreviate parameter names if possible (e.g. rgb = thisTask_loop.rgb)
    if thisTask_loop != None:
        for paramName in thisTask_loop:
            exec('{} = thisTask_loop[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    trial_loop = data.TrialHandler(nReps=10.0, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(Tasks),
        seed=None, name='trial_loop')
    thisExp.addLoop(trial_loop)  # add the loop to the experiment
    thisTrial_loop = trial_loop.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_loop.rgb)
    if thisTrial_loop != None:
        for paramName in thisTrial_loop:
            exec('{} = thisTrial_loop[paramName]'.format(paramName))
    
    for thisTrial_loop in trial_loop:
        currentLoop = trial_loop
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_loop.rgb)
        if thisTrial_loop != None:
            for paramName in thisTrial_loop:
                exec('{} = thisTrial_loop[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "Start_screen"-------
        continueRoutine = True
        # update component parameters for each repeat
        image.setImage(Stim)
        # setup some python lists for storing info about the mouse2
        mouse2.clicked_name = []
        gotValidClick = False  # until a click is received
        # keep track of which components have finished
        Start_screenComponents = [image, start_stim, mouse2]
        for thisComponent in Start_screenComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        Start_screenClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "Start_screen"-------
        while continueRoutine:
            # get current time
            t = Start_screenClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=Start_screenClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *image* updates
            if image.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                image.frameNStart = frameN  # exact frame index
                image.tStart = t  # local t and not account for scr refresh
                image.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(image, 'tStartRefresh')  # time at next scr refresh
                image.setAutoDraw(True)
            
            # *start_stim* updates
            if start_stim.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                start_stim.frameNStart = frameN  # exact frame index
                start_stim.tStart = t  # local t and not account for scr refresh
                start_stim.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(start_stim, 'tStartRefresh')  # time at next scr refresh
                start_stim.setAutoDraw(True)
            # *mouse2* updates
            if mouse2.status == NOT_STARTED and t >= 0.2-frameTolerance:
                # keep track of start time/frame for later
                mouse2.frameNStart = frameN  # exact frame index
                mouse2.tStart = t  # local t and not account for scr refresh
                mouse2.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(mouse2, 'tStartRefresh')  # time at next scr refresh
                mouse2.status = STARTED
                mouse2.mouseClock.reset()
                prevButtonState = mouse2.getPressed()  # if button is down already this ISN'T a new click
            if mouse2.status == STARTED:  # only update if started and not finished!
                buttons = mouse2.getPressed()
                if buttons != prevButtonState:  # button state changed?
                    prevButtonState = buttons
                    if sum(buttons) > 0:  # state changed to a new click
                        # check if the mouse was inside our 'clickable' objects
                        gotValidClick = False
                        try:
                            iter(start_stim)
                            clickableList = start_stim
                        except:
                            clickableList = [start_stim]
                        for obj in clickableList:
                            if obj.contains(mouse2):
                                gotValidClick = True
                                mouse2.clicked_name.append(obj.name)
                        if gotValidClick:  
                            continueRoutine = False  # abort routine on response
            mouseloc2=mouse2.getPos()
            if mouseloc2[0]==mouserec2[0] and mouseloc2[1]==mouserec2[1]:
                pass
            elif start_stim.contains(mouse):
                if t>minRT:
                    continueRoutine=False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in Start_screenComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "Start_screen"-------
        for thisComponent in Start_screenComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trial_loop.addData('image.started', image.tStartRefresh)
        trial_loop.addData('image.stopped', image.tStopRefresh)
        trial_loop.addData('start_stim.started', start_stim.tStartRefresh)
        trial_loop.addData('start_stim.stopped', start_stim.tStopRefresh)
        # store data for trial_loop (TrialHandler)
        x, y = mouse2.getPos()
        buttons = mouse2.getPressed()
        if sum(buttons):
            # check if the mouse was inside our 'clickable' objects
            gotValidClick = False
            try:
                iter(start_stim)
                clickableList = start_stim
            except:
                clickableList = [start_stim]
            for obj in clickableList:
                if obj.contains(mouse2):
                    gotValidClick = True
                    mouse2.clicked_name.append(obj.name)
        trial_loop.addData('mouse2.x', x)
        trial_loop.addData('mouse2.y', y)
        trial_loop.addData('mouse2.leftButton', buttons[0])
        trial_loop.addData('mouse2.midButton', buttons[1])
        trial_loop.addData('mouse2.rightButton', buttons[2])
        if len(mouse2.clicked_name):
            trial_loop.addData('mouse2.clicked_name', mouse2.clicked_name[0])
        trial_loop.addData('mouse2.started', mouse2.tStart)
        trial_loop.addData('mouse2.stopped', mouse2.tStop)
        # the Routine "Start_screen" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "Trials"-------
        continueRoutine = True
        # update component parameters for each repeat
        Task1_Stim.setImage(Stim)
        # setup some python lists for storing info about the mouse
        mouse.clicked_name = []
        gotValidClick = False  # until a click is received
        # keep track of which components have finished
        TrialsComponents = [Task1_Stim, B_rect, A_rect, mouse]
        for thisComponent in TrialsComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        TrialsClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "Trials"-------
        while continueRoutine:
            # get current time
            t = TrialsClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=TrialsClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *Task1_Stim* updates
            if Task1_Stim.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                Task1_Stim.frameNStart = frameN  # exact frame index
                Task1_Stim.tStart = t  # local t and not account for scr refresh
                Task1_Stim.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(Task1_Stim, 'tStartRefresh')  # time at next scr refresh
                Task1_Stim.setAutoDraw(True)
            
            # *B_rect* updates
            if B_rect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                B_rect.frameNStart = frameN  # exact frame index
                B_rect.tStart = t  # local t and not account for scr refresh
                B_rect.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(B_rect, 'tStartRefresh')  # time at next scr refresh
                B_rect.setAutoDraw(True)
            
            # *A_rect* updates
            if A_rect.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                A_rect.frameNStart = frameN  # exact frame index
                A_rect.tStart = t  # local t and not account for scr refresh
                A_rect.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(A_rect, 'tStartRefresh')  # time at next scr refresh
                A_rect.setAutoDraw(True)
            # *mouse* updates
            if mouse.status == NOT_STARTED and tThisFlip >= 0.2-frameTolerance:
                # keep track of start time/frame for later
                mouse.frameNStart = frameN  # exact frame index
                mouse.tStart = t  # local t and not account for scr refresh
                mouse.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(mouse, 'tStartRefresh')  # time at next scr refresh
                mouse.status = STARTED
                mouse.mouseClock.reset()
                prevButtonState = mouse.getPressed()  # if button is down already this ISN'T a new click
            if mouse.status == STARTED:  # only update if started and not finished!
                buttons = mouse.getPressed()
                if buttons != prevButtonState:  # button state changed?
                    prevButtonState = buttons
                    if sum(buttons) > 0:  # state changed to a new click
                        # check if the mouse was inside our 'clickable' objects
                        gotValidClick = False
                        try:
                            iter([A_rect, B_rect])
                            clickableList = [A_rect, B_rect]
                        except:
                            clickableList = [[A_rect, B_rect]]
                        for obj in clickableList:
                            if obj.contains(mouse):
                                gotValidClick = True
                                mouse.clicked_name.append(obj.name)
                        if gotValidClick:  
                            continueRoutine = False  # abort routine on response
            mouseloc=mouse.getPos()
            if mouseloc[0]==mouserec[0] and mouseloc[1]==mouserec[1]:
                pass
            elif B_rect.contains(mouse):
                if t>minRT:
                    Resp = 'B'
                    continueRoutine=False
            elif A_rect.contains(mouse):
                if t>minRT:
                    Resp = 'A'
                    continueRoutine=False
                else:
                    mousered=mouse.getPos()
                    
            thisExp.addData('AB_Chosen',Resp)
                
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in TrialsComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "Trials"-------
        for thisComponent in TrialsComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trial_loop.addData('Task1_Stim.started', Task1_Stim.tStartRefresh)
        trial_loop.addData('Task1_Stim.stopped', Task1_Stim.tStopRefresh)
        trial_loop.addData('B_rect.started', B_rect.tStartRefresh)
        trial_loop.addData('B_rect.stopped', B_rect.tStopRefresh)
        trial_loop.addData('A_rect.started', A_rect.tStartRefresh)
        trial_loop.addData('A_rect.stopped', A_rect.tStopRefresh)
        # store data for trial_loop (TrialHandler)
        x, y = mouse.getPos()
        buttons = mouse.getPressed()
        if sum(buttons):
            # check if the mouse was inside our 'clickable' objects
            gotValidClick = False
            try:
                iter([A_rect, B_rect])
                clickableList = [A_rect, B_rect]
            except:
                clickableList = [[A_rect, B_rect]]
            for obj in clickableList:
                if obj.contains(mouse):
                    gotValidClick = True
                    mouse.clicked_name.append(obj.name)
        trial_loop.addData('mouse.x', x)
        trial_loop.addData('mouse.y', y)
        trial_loop.addData('mouse.leftButton', buttons[0])
        trial_loop.addData('mouse.midButton', buttons[1])
        trial_loop.addData('mouse.rightButton', buttons[2])
        if len(mouse.clicked_name):
            trial_loop.addData('mouse.clicked_name', mouse.clicked_name[0])
        trial_loop.addData('mouse.started', mouse.tStartRefresh)
        trial_loop.addData('mouse.stopped', mouse.tStopRefresh)
        # the Routine "Trials" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "Feedback"-------
        continueRoutine = True
        # update component parameters for each repeat
        if Resp==AB:
            respond = 'Correct'
            Timeout = 0
            total_score += 1
            score = 1
        else:
            respond = 'Incorrect'
            Timeout = 2
            total_score -= 1
            score = 0
        
        thisExp.addData('TotalScore',total_score)
        thisExp.addData('TrialScore',score)
        
        
        win1.setText(respond)
        lose1.setText(respond)
        # keep track of which components have finished
        FeedbackComponents = [win1, lose1]
        for thisComponent in FeedbackComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        FeedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "Feedback"-------
        while continueRoutine:
            # get current time
            t = FeedbackClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=FeedbackClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *win1* updates
            if win1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                win1.frameNStart = frameN  # exact frame index
                win1.tStart = t  # local t and not account for scr refresh
                win1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(win1, 'tStartRefresh')  # time at next scr refresh
                win1.setAutoDraw(True)
            if win1.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > win1.tStartRefresh + 1.5-frameTolerance:
                    # keep track of stop time/frame for later
                    win1.tStop = t  # not accounting for scr refresh
                    win1.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(win1, 'tStopRefresh')  # time at next scr refresh
                    win1.setAutoDraw(False)
            
            # *lose1* updates
            if lose1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                lose1.frameNStart = frameN  # exact frame index
                lose1.tStart = t  # local t and not account for scr refresh
                lose1.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(lose1, 'tStartRefresh')  # time at next scr refresh
                lose1.setAutoDraw(True)
            if lose1.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > lose1.tStartRefresh + Timeout-frameTolerance:
                    # keep track of stop time/frame for later
                    lose1.tStop = t  # not accounting for scr refresh
                    lose1.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(lose1, 'tStopRefresh')  # time at next scr refresh
                    lose1.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in FeedbackComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "Feedback"-------
        for thisComponent in FeedbackComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        total_trials = trial_loop.thisN + 1
        acc_hist.append(score)
        last10 = acc_hist[-10:]
        avg_acc = (sum(last10))/10
        
        if(avg_acc >=0.8 and total_trials >= 10):
            trial_loop.finished = True
        
        trial_loop.addData('win1.started', win1.tStartRefresh)
        trial_loop.addData('win1.stopped', win1.tStopRefresh)
        trial_loop.addData('lose1.started', lose1.tStartRefresh)
        trial_loop.addData('lose1.stopped', lose1.tStopRefresh)
        # the Routine "Feedback" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        thisExp.nextEntry()
        
    # completed 10.0 repeats of 'trial_loop'
    
# completed 10.0 repeats of 'task_loop'


# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
